package com.cf.imes.module.system.service.machine;

import java.util.*;

import com.cf.imes.module.system.controller.admin.machine.vo.*;
import com.cf.imes.framework.common.pojo.PageResult;
import com.cf.imes.module.system.dal.dataobject.machine.MachineDO;

import javax.validation.Valid;

/**
 * 机台 Service 接口
 *
 * @author 晨丰科技
 */
public interface MachineService {

    /**
     * 创建机台
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createCutting(@Valid CuttingSaveReqVO createReqVO);

    /**
     * 更新机台
     *
     * @param updateReqVO 更新信息
     */
    void updateCutting(@Valid CuttingSaveReqVO updateReqVO);

    /**
     * 删除机台
     *
     * @param id 编号
     */
    void deleteCutting(Long id);

    /**
     * 获得机台
     *
     * @param id 编号
     * @return 机台
     */
    CuttingRespVO getCutting(Long id);

    /**
     * 获得机台分页
     *
     * @param pageReqVO 分页查询
     * @return 机台分页
     */
    PageResult<MachineDO> getPage(MachinePageReqVO pageReqVO);

    /**
     * 批量删除机台
     * @param ids
     */
    void batchDeleteCutting(List<Long> ids);

    Long createDrill(DrillSaveReqVO createReqVO);

    void updateDrill(DrillSaveReqVO updateReqVO);

    void deleteDrill(Long id);

    void batchDeleteDrill(List<Long> ids);

    DrillRespVO getDrill(Long id);

    List<MachineDO> list(Collection<Long> ids);

    Map<Integer, List<MachineVO>> getMachineTree(Long type);

    Boolean auth(MachineOrgAuthReq vo);

    PageResult<OrganMachineResp> organMachinePage(OrganMachinePage page);

    OrganMachineResp organMachineByOrganId(Long organId);

    PageResult<MachineDO> page(MachinePageReqVO pageParam);

    List<MachineSimpleRespVO> simpleList(Long organId,Long type);
}